# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations

import datetime as dt
import typing

import pydantic
import typing_extensions

from ...core.datetime_utils import serialize_datetime

T_Result = typing.TypeVar("T_Result")


class _Factory:
    def document_id(self, value: str) -> DocumentQueryId:
        return DocumentQueryId(__root__=_DocumentQueryId.DocumentId(type="document_id", value=value))

    def source_id(self, value: str) -> DocumentQueryId:
        return DocumentQueryId(__root__=_DocumentQueryId.SourceId(type="source_id", value=value))


class DocumentQueryId(pydantic.BaseModel):
    factory: typing.ClassVar[_Factory] = _Factory()

    def get_as_union(self) -> typing.Union[_DocumentQueryId.DocumentId, _DocumentQueryId.SourceId]:
        return self.__root__

    def visit(
        self, document_id: typing.Callable[[str], T_Result], source_id: typing.Callable[[str], T_Result]
    ) -> T_Result:
        if self.__root__.type == "document_id":
            return document_id(self.__root__.value)
        if self.__root__.type == "source_id":
            return source_id(self.__root__.value)

    __root__: typing_extensions.Annotated[
        typing.Union[_DocumentQueryId.DocumentId, _DocumentQueryId.SourceId], pydantic.Field(discriminator="type")
    ]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}


class _DocumentQueryId:
    class DocumentId(pydantic.BaseModel):
        type: typing_extensions.Literal["document_id"]
        value: str

        class Config:
            frozen = True

    class SourceId(pydantic.BaseModel):
        type: typing_extensions.Literal["source_id"]
        value: str

        class Config:
            frozen = True


DocumentQueryId.update_forward_refs()
